/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core/ES2015/DVContainer";
import { Type, enumGetBox, typeCast, Point_$type, markType } from "igniteui-react-core/ES2015/type";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core/ES2015/TrendLineType";
import { Brush } from "igniteui-react-core/ES2015/Brush";
import { PenLineCap_$type } from "igniteui-react-core/ES2015/PenLineCap";
import { DoubleCollection } from "igniteui-react-core/ES2015/DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-react-core/ES2015/IFastItemsSource";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { truncate, isNaN_ } from "igniteui-react-core/ES2015/number";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
export class AnchoredCategorySeries extends CategorySeries {
    constructor() {
        super();
        this.ot = null;
        this.ox = false;
        this.ov = null;
        this.oq = null;
        this.o0 = null;
        this.m2 = new CategoryFramePreparer(1, this, this.m6, this, this, this.m6.cn);
    }
    get ou() {
        if (this.ot == null) {
            this.ot = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.ot;
    }
    getHostReferenceValue() {
        return this.ed();
    }
    bf() {
        let a = new AnchoredCategorySeriesView(this);
        return a;
    }
    il(a) {
        super.il(a);
        this.op = a;
    }
    get valueColumn() {
        return this.ov;
    }
    set valueColumn(a) {
        if (this.ov != a) {
            let b = this.ov;
            this.ov = a;
            if (!this.ox) {
                this.raisePropertyChanged("ValueColumn", b, this.ov);
            }
        }
    }
    get pm() {
        return this.c(AnchoredCategorySeries.pb);
    }
    set pm(a) {
        this.h(AnchoredCategorySeries.pb, a);
    }
    c7(a) {
        let b = new Rect(0, 0, 0, 1, 1);
        let c = this.fetchXAxis();
        let d = this.fetchYAxis();
        let e = this.lj(this.bi);
        let f = c != null ? this.m2.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.ou.c$a(this, this.valueColumn, c, d, f, a);
    }
    om(a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        let d = new Array((b - a) + 1);
        let e = c.cc;
        let f = null;
        if (e) {
            f = c.i$b;
        }
        for (let g = a; g <= b; g++) {
            let h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    }
    ir(a, b, c, d) {
        super.ir(a, b, c, d);
        if (this.op.cz && this.op.cy.g$b(a, b, c, d)) {
            this.i4(false);
            this.ib();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.bw(this.o4);
                }
                let e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.ck()) {
                    this.op.cn.g(this.eq);
                    this.i4(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.bw(this.o4);
                }
                this.o0 = this.o4;
                break;
            case "ValueColumn":
                if (this.op.cz) {
                    this.op.cy.g$i();
                }
                let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.ck()) {
                    this.op.cn.g(this.eq);
                    this.i4(false);
                }
                this.pa();
                this.jh();
                break;
            case "TrendLineBrush":
                this.jf();
                break;
            case "ErrorBarSettings":
                this.i4(false);
                break;
            case "TrendLineType":
                this.ib();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.i4(false);
                break;
        }
    }
    an(a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    }
    hr(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.op.cn.g(this.eq);
                break;
        }
        if (this.op.cz) {
            this.op.cy.g$e(a, b, c, d);
        }
        this.pa();
        this.jh();
    }
    nx() {
        return this.oy(this.m6);
    }
    oy(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(a);
        let f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            let g = new ScalerParams(0, c, d, f.b8, e);
            if (f.ce) {
                g.b = this.ed();
            }
            b = f.dt(f.j7, g);
        }
        return b;
    }
    o9(a, b, c) {
        let d = this.oy(c);
        if (a.count > 0) {
            let e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    }
    on(a, b, c, d) {
        return this.oo(a, b, c, d, false);
    }
    oo(a, b, c, d, e) {
        return CategorySeries.ms(a, b, c, d, e);
    }
    du(a, b, c) {
        let d = super.du(a, b, c);
        let e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cn.d < 1) {
            d = false;
        }
        return d;
    }
    ho(a, b) {
        super.ho(a, b);
        let c = b;
        c.ct();
        if (c.cz) {
            c.cy.g$d();
        }
    }
    oc(a, b) {
        super.oc(a, b);
        this.m3(b).d(a, b);
    }
    of(a, b) {
        super.of(a, b);
        let c = typeCast(AnchoredCategorySeriesView.$, b);
        c.b0 = true;
        if (c.cz) {
            c.cy.g$g(a.p);
        }
        if (this.lu()) {
            CategoryMarkerManager.b(this, a.m, b.cq, this.lw);
            this.n9(b, a);
            b.cj();
        }
        this.o6(a, b);
    }
    i3(a, b, c, d, e) {
        super.i3(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.cn.g(this.eq);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.oq == null) {
            this.oq = new CategoryFrame(3);
        }
        this.oq.u();
        this.oc(this.oq, g);
        this.of(this.oq, g);
    }
    o6(a, b) {
    }
    jf() {
        super.jf();
        if (this.fd < 0) {
            return;
        }
        this.op.c3();
        if (this.trendLineBrush != null) {
            this.op.c1();
        }
        else {
            this.op.c0();
        }
    }
    fp(a, b) {
        if (this.op.cz && a == this.op.cy.g$j) {
            return null;
        }
        return super.fp(a, b);
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
    }
    get scaler() {
        return typeCast(ICategoryScaler_$type, this.fetchXAxis());
    }
    get yScaler() {
        return typeCast(IScaler_$type, this.fetchYAxis());
    }
    get bucketizer() {
        return this.op.cn;
    }
    get currentMode2Index() {
        return this.n0();
    }
    provideCollisionDetector() {
        if (this.or == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.a;
    }
    get trendlinePreparer() {
        return this.op.cz ? this.op.cy : null;
    }
    hx(a) {
        super.hx(a);
        if (this.op.cz) {
            this.a2.exportTrendlineData(this, a, this.op.cy.g$j);
        }
    }
    fl(a) {
        let b = this.fetchXAxis();
        let c = this.fetchYAxis();
        return this.ou.c$b(this, a, this.ny(this.bi), this.valueColumn, b, c, this.os == 1, (d) => super.fl(d));
    }
    get mayContainUnknowns() {
        return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
    }
    ed() {
        return Series.ee(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    }
    ao() {
        if (this.valueColumn == null) {
            return null;
        }
        let a = this.mx();
        let b = new ScalerParams(0, this.bs.mn, this.bs.m0, a.b8, this.getEffectiveViewport());
        let c = (a.dw(this.bs.m0.left, b));
        let d = (a.dw(this.bs.m0.right, b));
        let e = null;
        if (a.cc) {
            e = a;
            c = e.i$f(c);
            d = e.i$f(d);
        }
        else {
            c = Math.floor(c);
            d = Math.ceil(d);
        }
        if (isNaN_(c) || isNaN_(d)) {
            return null;
        }
        c = Math.max(0, Math.min(this.valueColumn.count - 1, c));
        d = Math.max(0, Math.min(this.valueColumn.count - 1, d));
        let f = 1.7976931348623157E+308;
        let g = -1.7976931348623157E+308;
        for (let h = truncate(c); h <= truncate(d); h++) {
            let i = h;
            if (e != null) {
                i = e.i$b._inner[h];
            }
            f = Math.min(f, this.valueColumn.item(i));
            g = Math.max(g, this.valueColumn.item(i));
        }
        return new AxisRange(f, g);
    }
    pa() {
        this.d4 = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
    }
    get useHighMarkerFidelity() {
        return this.nt;
    }
}
AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
AnchoredCategorySeries.pb = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
Type.dep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:os:pc', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:or:pd', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:o4:pl', [2, null], 'TrendLineType::pj', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::pi', [1, 1.5], 'TrendLinePeriod::ph', [1, 7], 'TrendLineBrush::pe', [Brush.$, null], 'TrendLineZIndex:oz:pk', [1, 1001], 'TrendLineDashArray:pn:pf', [DoubleCollection.$], 'TrendLineDashCap:po:pg', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
export class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.i = null;
        this.h = null;
        this.j = 0;
        this.i = a;
    }
    getBucketWithoutUnknowns(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 1.7976931348623157E+308;
        let h = -1.7976931348623157E+308;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    getBucket(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 0;
        let h = 0;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    cacheValues() {
        this.j = this.i.cw.valueColumn.count;
        this.h = this.i.cw.valueColumn.asArray();
    }
    unCacheValues() {
        this.h = null;
    }
}
AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
export class AnchoredCategorySeriesView extends CategorySeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cx = null;
        this.cw = a;
    }
    get cy() {
        if (this.cx == null) {
            this.cx = CategoryTrendLineManagerFactory.a(this.cx, this.e.ap(), this.e.jo, this.e, this.e.b2);
        }
        return this.cx;
    }
    set cy(a) {
        this.cx = a;
    }
    get cz() {
        return this.cx != null;
    }
    c3() {
        this.cw.pm = null;
    }
    c1() {
        this.cw.pm = this.cw.trendLineBrush;
    }
    c0() {
        this.cw.pm = this.cw.ku;
    }
    co() {
        return new AnchoredCategoryBucketCalculator(this);
    }
    c2() {
        this.cn.cacheValues();
    }
    c4() {
        this.cn.unCacheValues();
    }
    c5(a) {
        let b = this.cq.item(a);
        return this.cm(b);
    }
    a2(a, b) {
        if (a.d) {
            if (this.cw.trendLineType != 0 && !b) {
                let c = this.cy.g$j;
                c.ac = this.cw.trendLineThickness;
                c._stroke = this.cw.pm;
                c.ai = this.cw.pn;
                c.ad = this.cw.po;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    getDefaultTooltipTemplate() {
        return this.cw.ou.c$c(this.e, this.cw.o4);
    }
}
AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
